/**
 * Projeto : Ticketstac
 * Classe: Artista
 *
 */

package artista;

/**
 * Title:        Projeto de LP3
 * Description:
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author J Ricardo Catanho
 * @version 1.0
 */

/**
 * Classe Artista
 * Essa classe constroe e mantem o objeto artista, que tem como
 * atributos nome, banda da qual participa, estilo de musica,
 * instrumento que toca, funcao na banda, e comentarios sobre o artista e
 * sua banda.
 *
 * Limitacoes: Todo artista deve ter todos os atributos declarados
 *
 * Exemplo de uso:
 * Artista artistaMAria =  new Artista ("Maria","Santoro","10.000",
 *                                      081.2345678")
 * artistaMaria.equals( artistaJoao);
 *
 * @author J Ricardo Catanho
 *
 * @see Ticketstack.ArrayArtistas
 *
 */
public  class  Artista {
    protected String nomeArtista;
    private String nomeEmpresario;
    private String artistaCache;
    private String artistaFone;

    /**
     * Construtor da classe Artista
     * Construtor vazio
     *
     */
     public Artista() {
     }// construtor vazio

    /**
     * Construtor da classe Artista
     *
     * @param a    obtejo da classe Artista contendo o nome o telefone, o cache
     * e o nome do empresario do artista.
     *
     */
     public Artista (Artista a)  {
         this.nomeArtista = a.nomeArtista.toUpperCase();
         this.nomeEmpresario = a.nomeEmpresario.toUpperCase();
         this.artistaCache = a.artistaCache.toUpperCase();
         this.artistaFone = a.artistaFone.toUpperCase();
     }// Construtor Artista

    /**
     * Construtor da classe Artista
     *
     * @param nomeArtista        nome do artista no sistema
     * @param nomeEmpresario     nome do empresario do artista
     * @param artistaCache       cache do artista
     * @param artistaFone        telefone do artista para contato
     *
     */
     public Artista(String nomeArtista, String nomeEmpresario,
                    String artistaCache, String artistaFone) {
      this.nomeArtista = nomeArtista.toUpperCase();
      this.nomeEmpresario = nomeEmpresario.toUpperCase();
      this.artistaCache = artistaCache.toUpperCase();
      this.artistaFone = artistaFone.toUpperCase();
    }// Constutor Artista

    /**
     * Este metodo retorna o nome de um  Artista.
     *
     * @return nomeArtista   String com o nome do artista
     *
     */
     public String getNomeArtista()  {
         return nomeArtista;
     }// Metodo getNomeArtista

    /**
     * Este metodo atribue uma String ao nome de um objeto Artista
     * A String e colocada em maiusculas e sao retirados os espacos iniciais
     * e finais nao representativos
     *
     * @param nomeArtista    String com o nome do artista
     *
     */
     public void setNomeArtista(String nomeArtista)  {
         this.nomeArtista = nomeArtista.toUpperCase().trim();
     }// Metodo setNomeArtista

   /**
     * Este metodo retorna o cache de um objeto Artista.
     *
     * @return artistaCache    String com o cache do artista desejado
     *
     */

     public String getArtistaCache() {
         return artistaCache;
     }// Metodo getArtistaCache

    /**
     * Este metodo retorna o telefone de um objeto Artista.
     *
     * @return artistaFone    String com o telefone do artista
     *
     */

     public String getArtistaFone()  {
         return artistaFone;
     }// Metodo getArtistaFone

    /**
     * Este metodo retorna o nome do empresario do artista.
     *
     * @return nomeEmpresario    String com o nome do empresadio do artista
     *
     */

     public String getNomeEmpresario()  {
         return nomeEmpresario;
     }// Metodo getNomeEmpresario

    /**
     * Este metodo atribue uma String ao nomeEmpresario de um objeto Artista
     * A String e colocada em maiusculas e sao retirados os espacos iniciais
     * e finais nao representativos
     *
     * @param nomeEmpresario    String com o bome do artista
     */

     protected void setNomeEmpresario(String nomeEmpresario)  {
         this.nomeEmpresario = nomeEmpresario.toUpperCase().trim();
     }// Metodo setNomeEmpresario

    /**
     * Este metodo atribue uma String ao telefone de um objeto Artista
     * Sao retirados os espacos iniciais e finais nao representativos
     *
     * @param artistaFone    String com o telefone do artista
     *
     */

     protected void setArtistaFone(String artistaFone)  {
         this.artistaFone = artistaFone.trim();
     }// Metodo setArtistaFone

    /**
     * Este metodo atribue uma String ao cache de um  Artista
     * Sao retirados os espacos iniciais e finais nao representativos
     *
     * @param artistaCache    String com o cache do artista
     */

     protected void setArtistaCache(String artistaCache)  {
         this.artistaCache = artistaCache.trim();
     }// Metodo setArtistaCache


    /**
     * Este metodo retorna um boleano da comparacao de 2 objetos Artista
     * utilizando o nome e a banda, ou somente o nome
     *
     * @param a           objeto Artista contendo o artista a ser comparado
     *
     * @return retorno    booleano contendo o resusltado do equals
     *
     */

     public boolean equals(Artista a)  {
         boolean retorno;

         if (this.nomeArtista.trim().equalsIgnoreCase(a.nomeArtista.trim())&&
             this.nomeEmpresario.trim().equalsIgnoreCase(a.nomeEmpresario.trim(
             )) && this.artistaCache.trim().equalsIgnoreCase(
             a.artistaCache.trim()) && this.artistaFone.trim(
             ).equalsIgnoreCase(a.artistaFone.trim()))  {
             retorno = true;
         } else  {
             retorno = false;
         }
         return retorno;
    }// Metodo equals

     public boolean equals(String nomeArtista, String nomeEmpresario,
            String artistaCache, String artistaFone)  {
            boolean retorno;

            if (this.nomeArtista.equalsIgnoreCase(nomeArtista)&&
                this.nomeEmpresario.equalsIgnoreCase(nomeEmpresario)&&
                this.artistaCache.equalsIgnoreCase(artistaCache)&&
                this.artistaFone.equalsIgnoreCase(artistaFone))  {
                retorno = true;
            } else  {
                retorno = false;
            }
            return retorno;
     }// Metodo equals

     public boolean matchParcial (String nome){
        boolean retorno = false;
        if (this.nomeArtista.indexOf(nome) >= 0)retorno = true;
        return retorno;
     }//matchParcial

     public boolean matchParcial (Artista a){
        boolean retorno = false;
        if (this.nomeArtista.indexOf(a.getNomeArtista()) >= 0)retorno = true;
        return retorno;
     }//matchParcial

     public String toString(){
        return this.nomeArtista;
     }


}// Classe Artista