/**
 * Projeto :    Ticketstac
 * Classe:      RepositorioCompradores
 *
 */

package comprador;

import java.lang.String;
import comprador.Comprador;
import comprador.IteratorComprador;

/**
 * Title:           Projeto de LP3
 * Description:     Interface para Repositorio de Cadastro de Compradores
 * Copyright:       Copyright (c) 2002
 * Company:         Grupo de LP3
 * @author          Cristiane Gomes
 * @version         2.0
 */

public interface RepositorioCompradores  {

    public void inserir (Comprador a) ;
    public boolean existe(Comprador c);
    public boolean existe(String  ident);
    public Comprador procurarId(String id) throws CompradorNaoEncontradoException;
    public int encontrarPosicao(String id);
    public void remover( String id) throws CompradorNaoEncontradoException;
    public Comprador[] listarCompradores();
    public int getNumeroCompradoresCadastrados();
    public IteratorComprador getIterator();

}//RepositorioCompradores