package fachada;
import ticket.*;
import show.*;
import artista.*;
import comprador.*;
import venda.*;
import java.util.GregorianCalendar;

/**
 * Title:        Projeto de  LP3
 * Description:  Controle de Shows
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */

public class Fachada {


    private CadastroArtista artistas;
    private CadastroComprador compradores;
    private CadastroShows shows;
    private CadastroTickets tickets;
    private CadastroVendas vendas;
    private static Fachada instancia;


    public Fachada() {
        artistas = new CadastroArtista( new RepositorioArtistasArray() );
        compradores = new CadastroComprador( new RepositorioCompradoresArray() );
        shows = new CadastroShows( new RepositorioShowsLista() );
        tickets = new CadastroTickets( new RepositorioTicketsLista( ));
        vendas =  new CadastroVendas (  new RepositorioVendasArray());

    }

    /**
    * Mtodos Cadastrar
    *
    */
    public void cadastrarArtista( Artista artista )
            {
        artistas.inserir( artista );
    }
    public void cadastrarComprador ( Comprador comprador ) {
        compradores.inserir( comprador );


    }
    public void cadastrarShow ( Show show ) {
        shows.cadastrar( show );
    }
    public void cadastrarTicket ( Ticket ticket ) {
        tickets.cadastrar( ticket );
    }
    public void cadastrarVenda ( Venda venda ) {
        vendas.inserir( venda );
    }

    /**
    * Mtodos de descadastrar
    *
    */
    public void desCadastrarArtista(String nome )
    throws ArtistaNaoEncontradoException
    {
        artistas.remover( nome );
    }
    public void desCadastrarComprador ( String id )
          throws CompradorNaoEncontradoException {
        compradores.remover( id );
    }
    public void desCadastrarShow ( Show show )
        throws ListaVaziaException {
        shows.descadastrar( show );
    }
    public void desCadastrarTicket ( Ticket ticket ) {
        tickets.remover( ticket);
    }
    public void desCadastrarVenda ( Venda venda ) {
        vendas.remover( venda);
    }

    /**
    * Mtodos procurar
    *
    */

    public Artista procurarArtista( String nome )
    throws ArtistaNaoEncontradoException{
        return artistas.procurarArtistaNome( nome );
    }

    public Comprador procurarComprador( String id )
        throws CompradorNaoEncontradoException{
        return compradores.getInformacoesComprador( id);
    }

    public Show[] procurarShow( Show show )
            throws showNaoEncontradoException{
        return shows.buscar( show );
    }

    public Ticket[] procurarTicket( Ticket ticket ){
        return tickets.procurar( ticket );
    }

    /**
    * Mtodos Listar
    *
    */
    public RepositorioShows listarShow( ){
        return shows.buscar();
    }

    public RepositorioTickets listarTicket( ){
        return tickets.listar();
    }


    public RepositorioVendas listarVenda( ){
        return vendas.listar();
    }

    public RepositorioArtistas listarArtista( ) {
        return artistas.listar();
    }

     public RepositorioCompradores listarComprador( ){
        return compradores.listar();
    }

    /**
    * Mtodos Atualizar
    *
    */
    public void atualizarShow( Show show ){
        shows.alterar( show );
    }

    public void atualizarTicket( float valor, int tipo, Show show ){
        tickets.alterar( valor, tipo, show);
    }

    public static Fachada obterInstancia() {
	 if ( instancia == null) {
	   instancia = new Fachada();
	 }
	 return instancia;
  }
}