package show;

import java.util.GregorianCalendar;
import artista.Artista;
import artista.CadastroArtista;
import artista.IteratorArtista;
import artista.IteratorArtistaArray;
import artista.RepositorioArtistas;
import artista.RepositorioArtistasArray;


/**
 * Title:        Projeto de LP3
 * Description:  Cadastro de Shows
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author
 * @version 1.0
 */


public class CadastroShows {

    private RepositorioShows shows;


    /**
     * Construtor da classe CadastroShows.
     *
     */
    public CadastroShows(){
        shows = new RepositorioShowsLista();
    }

    /**
     * Construtor da classe CadastroShows.
     *
     * @param repShows	 RepositorioShowsLista de shows;
     */
    public CadastroShows( RepositorioShows repShows )
     {
         shows =  repShows;
     }

    /**
     * Cadastra um novo show.
     *
     * @param show	 Show a ser cadastrado;
     */
    public void cadastrar(Show show){
        if(!shows.existe( show  )) {
            shows.inserir( show );
        }
    }

     /**
     * Descadastra um show.
     *
     * @param show	 Show a ser descadastrado;
     */
    public void descadastrar(Show show)
        throws ListaVaziaException{
        shows.remover(show);
    }

    /**
     * Atualiza um show.
     *
     * @param show	 Show a ser modificado;
     */
    public void alterar(Show show){
        shows.alterar( show );
    }

     /**
     * Busca determinados shows por alguns parametros.
     *
     * @param show	 Show a ser modificado;
     */
    public Show[] buscar(Show show)
        throws showNaoEncontradoException{
        Show[] retorno,retornoaux;
        //int i = shows.procurar( show ).length;

        retornoaux = new Show[100];
        retorno = shows.procurar(show);

        return retorno;
    }

     /**
     * Busca todos os shows
     *
     * @param show	 Show a ser modificado;
     */
    public RepositorioShows buscar(){

        RepositorioShows retorno = new RepositorioShowsLista();

        IteratorShow showIte = shows.getIterator();
         while(showIte.hasNext()){
              retorno.inserir(showIte.next());
        }
        return retorno;
    }


}
