package show;


import artista.Artista;
import artista.CadastroArtista;
import artista.IteratorArtista;
import artista.IteratorArtistaArray;
import artista.RepositorioArtistas;
import artista.RepositorioArtistasArray;


/**
 * Title:        Projeto de LP3
 * Description:  Classe Show - Representa um Show
 * Copyright:    Copyright (c) 2002
 * Company:
 * @author Murillo Pontual
 * @version 1.0
 */


public class Show {


    private String nomeShow;
    private Artista artista;
    private String data;
    private String hora;
    private int numeroCadeira;
    private int numeroMesa;
    private int numeroEmPe;
    private String nomeLocal;
    private int lotacaoCadeira;
    private int lotacaoMesa;
    private int lotacaoEmPe;


    /**
     * Construtor da classe Show
     */
    public Show() {

        this.nomeShow = null;
        this.artista = null;
        this.data = null;
        this.hora = null;
        this.numeroCadeira = 0;
        this.numeroMesa = 0;
        this.numeroEmPe = 0;
        this.nomeLocal = null;
        this.lotacaoCadeira = 0;
        this.lotacaoMesa = 0;
        this.lotacaoEmPe = 0;

      }

    /**
     * Construtor da classe Show
     *
     * @param nomeShow       nome do show
     * @param data     data de incio do show
     * @param nomeLocal      nome do Local onde acontecer o show
     */
    public Show(String nomeShow,String data,String nomeLocal) {

        this.nomeShow = nomeShow;
        this.artista = null;
        this.data = data;
        this.hora = null;
        this.numeroCadeira = 0;
        this.numeroMesa = 0;
        this.numeroEmPe = 0;
        this.nomeLocal = nomeLocal;
        this.lotacaoCadeira = 0;
        this.lotacaoMesa = 0;
        this.lotacaoEmPe = 0;
  }

    /**
     * Construtor da classe Show
     *
     * @param nomeShow           nome do show
     * @param artista            nome do artista
     * @param data         data de incio do show
     * @param hora            data de fim do show
     * @param nomeLocal          nome do Local onde ocorrerar o show
     * @param LotacaoCadeira     maximo de cadeiras de um show
     * @param LotacaoMesa        maximo de mesas de um show
     * @param LotacaoEmPe        maximo de pessoas em pe de um show
     */
    public Show(String nomeShow,Artista artista, String data,
        String hora,String nomeLocal,int lotacaoCadeira,
        int lotacaoMesa, int lotacaoEmPe) {

        this.nomeShow = nomeShow;
        this.artista = artista;
        this.data = data;
        this.hora = hora;
        this.numeroCadeira = 0;
        this.numeroMesa = 0;
        this.numeroEmPe = 0;
        this.nomeLocal = nomeLocal;
        this.lotacaoCadeira = lotacaoCadeira;
        this.lotacaoMesa = lotacaoMesa;
        this.lotacaoEmPe = lotacaoEmPe;

  }

    /**
     * Construtor da classe Show
     *
     * @param nomeShow           nome do show
     * @param artista            nome do artista
     * @param data         data de incio do show
     * @param hora            data de fim do show
     * @param numeroCadeira      nmero de cadeiras vendidas
     * @param numeroMesa         nmero de mesas vendidas
     * @param numeroEmPe         nmero de pessoas em p vendidas
     * @param nomeLocal          nome do Local onde ocorrerar o show
     * @param LotacaoCadeira     maximo de cadeiras de um show
     * @param LotacaoMesa        maximo de mesas de um show
     * @param LotacaoEmPe        maximo de pessoas em pe de um show
     */
    public Show(String nomeShow,Artista artista,
        String data,String hora,
        int numeroCadeira,int numeroMesa,int numeroEmPe,String nomeLocal,
        int lotacaoCadeira, int lotacaoMesa,int lotacaoEmPe) {

        this.nomeShow = nomeShow;
        this.artista = artista;
        this.data = data;
        this.hora = hora;
        this.numeroCadeira = numeroCadeira;
        this.numeroMesa = numeroMesa;
        this.numeroEmPe = numeroEmPe;
        this.nomeLocal = nomeLocal;
        this.lotacaoCadeira = lotacaoCadeira;
        this.lotacaoMesa = lotacaoMesa;
        this.lotacaoEmPe = lotacaoEmPe;

    }

    /**
     * Retorna o Objeto Artista
     *
     * @return um objeto artista
     */
    public Artista getArtista() {
        return artista;
    }

     /**
     * Seta um artista
     *
     * @param artista       Um tipo Artista contendo artista
     */
    public void setArtista(Artista artista) {
        this.artista = artista;
    }

    /**
     * Retorna a Hora Final
     *
     * @return um String
     */
    public String getHora() {
        return hora;
    }


    /**
     * Retorna a Data Inicial
     *
     * @return String
     */
    public String getData() {
        return data;
    }

    /**
     * Retorna o nome do Show
     *
     * @return uma String
     */
    public String getNomeShow() {
       return nomeShow;
    }

    /**
     * Retorna o Numero de Cadeiras
     *
     * @return um int
     */
    public int getNumeroCadeira() {
        return numeroCadeira;
    }

    /**
     * Retorna o numero de pessoas em pe
     *
     * @return um int
     */
    public int getNumeroEmPe() {
        return numeroEmPe;
    }


    /**
     * Retorna o numero de mesas
     *
     * @return um int
     */
    public int getNumeroMesa() {
        return numeroMesa;
    }

    /**
     * Seta a data final
     *
     * @param hora       Um gregoriamCalendar contendo a data final
     */
    public void setHora(String hora) {
        this.hora = hora;
    }

    /**
     * Seta a data inicinal
     *
     * @param data       Um gregoriamCalendar contendo a data inicial
     */
    public void setData(String data) {
        this.data = data;
    }

    /**
     * Seta o nome do Show
     *
     * @param nomeShow          Uma String contendo o nome do show
     */
    public void setNomeShow(String nomeShow) {
        this.nomeShow = nomeShow;
    }

    /**
     * Seta o numero de cadeira
     *
     * @param numeroCadeira     Um int contendo o numero de cadeiras
     */
    public void setNumeroCadeira(int numeroCadeira) {
        this.numeroCadeira = numeroCadeira;
    }

    /**
     * Seta o numero de pessoas em pe
     *
     * @param numeroEmPe       Um int contendo o numero de pessoas em pe
     */
    public void setNumeroEmPe(int numeroEmPe) {
        this.numeroEmPe = numeroEmPe;
    }

    /**
     * Seta o numero de Mesas
     *
     * @param numeroMesa     Um int contendo o numero de mesas
     */
    public void setNumeroMesa(int numeroMesa) {
        this.numeroMesa = numeroMesa;
    }

    /**
     * Retorna a lotacao de cadeira
     *
     * @return um int
     */
    public int getLotacaoCadeira() {
        return lotacaoCadeira;
    }

    /**
     * Seta o numero de lotacao de cadeiras
     *
     * @param lotacaoCadeira     Um int contendo a lotacao de cadeiras
     */
    public void setLotacaoCadeira(int lotacaoCadeira) {
        this.lotacaoCadeira = lotacaoCadeira;
    }

    /**
     * Seta o numero de lotacao de pessoas em pe
     *
     * @param lotacaoEmPe     Um int contendo a lotacao de pessoas em pe
     */
    public void setLotacaoEmPe(int lotacaoEmPe) {
        this.lotacaoEmPe = lotacaoEmPe;
    }

    /**
     * Retorna a lotacao de pessoas em pe
     *
     * @return um int
     */
    public int getLotacaoEmPe() {
        return lotacaoEmPe;
    }

    /**
     * Retorna a lotacao de mesas
     *
     * @return um int
     */
    public int getLotacaoMesa() {
        return lotacaoMesa;
    }

    /**
     * Retorna o local
     *
     * @return uma String contendo o local
     */
    public String getNomeLocal() {
        return nomeLocal;
    }

    /**
     * Seta o nome do local
     *
     * @param nomeLocal     Uma string contendo nome do local
     */
    public void setNomeLocal(String nomeLocal) {
        this.nomeLocal = nomeLocal;
    }

    /**
     * Seta a lotacao de mesas
     *
     * @param lotacaoMesa    Um int com a lotacao de mesa
     */
    public void setLotacaoMesa(int lotacaoMesa) {
        this.lotacaoMesa = lotacaoMesa;
    }

    /**
     * Verifica se um show  igual a outro.
     *
     * @param show        Show a ser verificado;
     * @return	 Retorna "true" se for igual. Caso contrario, retorna "false";
     */
    public boolean equals(Show show)
       {

        boolean retorno;

        if(this.artista.equals(show.artista) &&
           this.nomeShow == show.nomeShow &&
           this.data.equals(show.data) &&
           this.hora.equals(show.hora) &&
           this.numeroCadeira == show.numeroCadeira &&
           this.numeroMesa == show.numeroMesa &&
           this.numeroEmPe == show.numeroEmPe &&
           this.nomeLocal == show.nomeLocal &&
           this.lotacaoCadeira == show.lotacaoCadeira &&
           this.lotacaoMesa == show.lotacaoMesa &&
           this.lotacaoEmPe == show.lotacaoEmPe
        ){
            retorno = true;
        } else {
            retorno = false;
        }
        return retorno;
    }



    /**
     * Verifica se um show "match" outro.
     *
     * @param show        Show a ser verificado;
     * @return		           Retorna "true" se "match".
     *                         Caso contrario, retorna "false";
     */
    public boolean match(Show show){
        boolean retorno = true;
/*
        if(! this.data.equals(show.getData())){
            retorno = false;
            }
*/
         if(! this.nomeShow.equals(show.getNomeShow())){
            retorno = false;
            }
/*
         if(! this.nomeLocal.equals(show.getNomeLocal())){
            retorno = false;
            }
*/
        return retorno;
    }

     /**
     * Verifica se a lotacao de cadeiras esta esgotada
     *
     *
     * @return		           Retorna "true" se "esgotou".
     *                         Caso contrario, retorna "false";
     */
    public boolean esgotadoCadeira(){

        boolean retorno = false;

        if(this.lotacaoCadeira - this.numeroCadeira == 0){
            retorno = true;
        }

        return retorno;

    }

     /**
     * Verifica se a lotacao de em Pe ta esgotada
     *
     *
     * @return		           Retorna "true" se "esgotou".
     *                         Caso contrario, retorna "false";
     */
    public boolean esgotadoEmPe(){

        boolean retorno = false;

        if(this.lotacaoEmPe - this.numeroEmPe == 0){
                retorno = true;
            }

        return retorno;
    }

     /**
     * Verifica se a lotacao de mesas ta esgotada
     *
     *
     * @return		           Retorna "true" se "esgotou".
     *                         Caso contrario, retorna "false";
     */
     public boolean esgotadoMesa(){

        boolean retorno = false;

        if(this.lotacaoMesa - this.numeroMesa == 0){
            retorno = true;
        }
        return retorno;
     }

     /**
     * Incrementa Cadeira
     *
     * @param quantidade    quantidade a ser incrementada
     */
    public void incrementaCadeira( int quantidade){

        this.numeroCadeira = this.numeroCadeira + quantidade;
    }


    /**
     * Incrementa em Pe
     *
     * @param quantidade    quantidade a ser incrementada
     */
     public void incrementaEmPe( int quantidade){

        this.numeroEmPe = this.numeroEmPe + quantidade;

    }

    /**
     * Incrementa mesa
     *
     *@param quantidade    quantidade a ser incrementada
     */
    public void incrementaMesa( int quantidade){

        this.numeroMesa = this.numeroMesa + quantidade;
    }

     /**
     * Quantidade de Cadeira que restam
     *
     * @return           quantidade de cadeira que restam
     *
     */
     public int quantidadeCadeira(){

        int retorno;
        retorno = this.lotacaoCadeira - this.numeroCadeira;
        return retorno;
    }

     /**
     * Quantidade de Pessoas em Pe que restam
     *
     * @return		           quantidade de pe que restam
     *
     */
    public int quantidadeEmPe(){
        int retorno;
        retorno = this.lotacaoEmPe - this.numeroEmPe;
        return retorno;
   }


     /**
     * Quantidade de Mesas que restam
     *
     * @return		           quantidade de mesa que restam
     */
    public int quantidadeMesa(){
        int retorno;
        retorno = this.lotacaoMesa - this.numeroMesa;
        return retorno;
     }

    public String toString(){
      return this.nomeShow;
    }

}
