package ticket;

import show.Show;
import show.CadastroShows;
import show.RepositorioShowsLista;

/**
 * Title:         Projeto de Lp3
 * Description:   Classe Ticket
 * Copyright:     Copyright (c) 2002
 * Company:
 * @author        Lucas Carneiro
 * @version       1.0
 */

public class CadastroTickets {

    private RepositorioTickets tickets;



    /**
     * Construtor da classe CadastroTickets.
     *
     */
    public CadastroTickets(){
        tickets = new RepositorioTicketsLista();
    }

    public CadastroTickets( RepositorioTickets repTickets) {
        this.tickets = repTickets;

    }



    public RepositorioTickets getTickets() {
        return tickets;

    }
    public void setTickets(RepositorioTickets tickets) {
        this.tickets = tickets;

    }

    /**
     * mtodo cadastrar
     *
     */

    public void cadastrar ( Ticket ticket ){

        if ( !this.tickets.existe( ticket ) ){
            this.tickets.inserir( ticket );

        }

    }

    /**
     * mtodo Remover
     *
     */

    public void remover ( Ticket ticket ){
        if ( this.tickets.existe( ticket ) ) {
        this.tickets.remover( ticket );

        }

   }


    /**
     * mtodo Alterar
     *
     */

    public boolean alterar ( float valor, int tipo, Show show ){
       boolean retorno = false;
       if ( valor != 0 && tipo != 0 && show != null ) {
           if (this.tickets.alterar( valor, tipo, show)) {
               retorno = true;
           }

       }

       return retorno;
    }

    /**
     * mtodo Listar
     *
     */

    public RepositorioTickets listar(){
        RepositorioTickets retorno = new RepositorioTicketsLista();
        IteratorTicket ticketIte = tickets.getIterator();
        while(ticketIte.hasNext()){
              retorno.inserir(ticketIte.next());
        }
        return retorno;

    }









    public Ticket[] procurar( Ticket ticket ){
        Ticket[] retorno = new Ticket[100];
        if ( ticket != null ){
            retorno = this.getTickets().procurar( ticket );

        }
        return retorno;
    }

}