package ticket;

import show.*;

/**
 * Title:         Projeto de Lp3
 * Description:   Classe Ticket
 * Copyright:     Copyright (c) 2002
 * Company:
 * @author        Lucas Carneiro
 * @version       1.0
 */



public class RepositorioTicketsLista
            implements RepositorioTickets{

    private Ticket atual;
    private RepositorioTicketsLista proximo;

 /**
  * Construtor de ListaTicket.
  * Este construtor no recebe nada como
  * parmetro e cria um novo elemento para
  * o repositrio.
  */

    public RepositorioTicketsLista () {

        this.atual = null;
        this.proximo = null;


    }

    /**
     * Construtor de ListaTicket.
     * Este construtor recebe como parametro
     * um objeto do tipo ticket e o insere
     * na lista.
     */

    public RepositorioTicketsLista( Ticket ticket ) {

        if ( ticket != null ){
            this.atual = ticket;
            this.proximo = new RepositorioTicketsLista();
        }
    }


    public Ticket getAtual() {
        return atual;
    }
    public RepositorioTicketsLista getProximo() {
        return proximo;
    }
    public void setAtual(Ticket atual) {
        this.atual = atual;
    }
    public void setProximo(RepositorioTicketsLista proximo) {
        this.proximo = proximo;
    }


    /**
     * Mtodos de retornos de Valores
     */


    /**
     * Mtodo Inserir
     *
     */
    public void inserir( Ticket ticket  ){

        if ( this.atual != null ){
            this.proximo.inserir ( ticket );
        }
        else{
             this.atual = ticket;
             this.proximo = new RepositorioTicketsLista();
        }

  }



    /**
     * Mtodo Procurar
     *
     */

    public Ticket[] procurar ( Ticket ticket ){

        Ticket[] retorno;
        int contador = 1;
        retorno  = new Ticket[100];
        RepositorioTicketsLista pointer = this;

        if ( ticket != null ){
            while ( pointer.atual != null ){
                if ( pointer.atual.getShow().equals( ticket.getShow() )
                     && ticket.getTipo() == pointer.atual.getTipo() ) {

                       retorno [ contador ] = pointer.atual;
                       pointer = pointer.proximo;
                       contador ++;

                }else{
                       pointer.atual = pointer.proximo.getAtual();
                       pointer.proximo = pointer.proximo.getProximo();
                }

            }
        }else{
            while ( pointer.atual != null ){
                 retorno [ contador ] = pointer.atual;
                 pointer = pointer.proximo;
                 contador ++;
             }
        }
        return retorno;
    }

    /**
     * Mtodo Procurar
     *
     */

    public boolean remover( Ticket ticket ) {

        RepositorioTicketsLista pt = this;
        boolean retorno = false;

        while( pt.atual != null && ! pt.atual.equals( ticket )) {
            pt = pt.proximo;

        }
        if ( pt.atual != null) {
            pt.atual = pt.proximo.getAtual();
            pt.proximo = pt.proximo.getProximo();

        }

        return retorno;

    }

    /**
     * Mtodo Existir
     *
     */

    public boolean existe( Ticket ticket )
        {
         boolean retorno = false;
         RepositorioTicketsLista pointer = this;

         if( ticket != null ) {
             while( pointer.atual != null && !pointer.atual.equals( ticket ) ) {
                 pointer = pointer.proximo;

             }
             if( pointer.atual != null ) {
                  retorno = true;

             }else {
                 retorno = false;

             }
          }

          return retorno;
    }



    /**
      * Metodo Alterar
      * Alterando o valor de um ticket pelo tipo e pelo show
      *
      */


     public boolean alterar( float valor, int tipo, Show show ){


        RepositorioTicketsLista pt = this;
        boolean retorno = false;

        if ( valor != 0 && tipo != 0) {

            while ( pt.atual != null ) {
                if ( pt.atual.getTipo() == tipo
                    && pt.atual.getShow().equals( show )) {
                    pt.atual.setValorVenda( valor );
                    pt = pt.proximo;
                    retorno = true;

                }else{
                    pt.atual = pt.proximo.getAtual();
                    pt.proximo = pt.proximo.getProximo();

                }

            }

       }
       return retorno;
    }

      public IteratorTicket getIterator(){
        int i;
        RepositorioTicketsLista pt = this;
        IteratorTicketLista iterator = new IteratorTicketLista();

        while (pt.atual!=null) {
                iterator.add(pt.atual);
                pt = pt.proximo;
        }//while

        return iterator;
     }//getIterator

}