package ticket;

import show.Show;
import show.RepositorioShowsLista;
import show.CadastroShows;

/**
 * Title:         Projeto de Lp3
 * Description:   Classe Ticket
 * Copyright:     Copyright (c) 2002
 * Company:
 * @author        Lucas Carneiro
 * @version       1.0
 */




/**
 * Comentrios da Classe Ticket:
 * Para a classe ticket so decladas os seguintes atributos:
 *
 * @param nome             Nome do Ticket
 * @param tipo             Tipo do ticket -> 1 = cadeira, 2 = mesa, 3 em p
 * @param valorVenda       Valor para Venda do Ticket
 * @param show             Show para onde o ticket foi cadastrado
 */

 public class Ticket {

    private String nome;
    private int tipo;
    private float valorVenda;
    private Show show;

    /**
     * Construtor sem parametros
     */

    public Ticket() {

        this.nome = null;
        this.tipo = 0;
        this.valorVenda = 0;
        this.show = null;
    }

    /**
     * Construtor com parametros
     */

    public Ticket ( String nome,int tipo, float valorVenda, Show show) {

        this.nome = nome;
        this.tipo = tipo;
        this.valorVenda = valorVenda;
        this.show = show;

    }
    public Show getShow() {
        return show;
    }
    public int getTipo() {
        return tipo;
    }
    public float getValorVenda() {
        return valorVenda;
    }
    public void setValorVenda(float valorVenda) {
        this.valorVenda = valorVenda;
    }
    public void setTipo(int tipo) {
        this.tipo = tipo;
    }
    public void setShow(Show show) {
        this.show = show;
    }
    public String getNome() {
        return nome;
    }
    public void setNome(String nome) {
        this.nome = nome;
    }

    /**
     * Metodo equals
     */


    public boolean equals( Ticket ticket) {

        boolean retorno = false;

        if ( ticket != null ){
            if ( this.nome == ticket.getNome() && this.tipo == ticket.getTipo()
                 && this.valorVenda == ticket.getValorVenda()
                 && this.show.equals ( ticket.getShow() ) ){

                retorno = true;
            }

        }
        else{
            throw new RuntimeException( "Objeto Ticket nulo." );
        }
        return retorno;
    }

    /**
     * Metodo equals
     */

    public boolean match ( Ticket ticket ){

        boolean retorno = false;

        if ( ticket.getNome() == this.getNome() && this.getShow().equals( ticket.getShow() ) ){
            retorno = true;
        }
        return retorno;
    }

    public String toString(){
        return this.getNome();
    }


}