package venda;
import ticket.*;
import comprador.*;
import show.*;


public class RepositorioVendasArray
        implements RepositorioVendas{

  private Venda[] listaVendas;// array de compradores
  private final int NUMERO_MAXIMO = 1000; // numero maximo de compradores
  private static int indice;


  public RepositorioVendasArray() {
    listaVendas = new Venda[ NUMERO_MAXIMO ];
    indice = 0;
  }// construtor RepositorioCompradoresArray

    public void inserir ( Ticket ticket, int qtdePedida, Comprador comprador){
     if ( (this.existe( ticket, qtdePedida, comprador )== false)){
        listaVendas[ indice] = new Venda( ticket,qtdePedida, comprador);
        indice = indice + 1;
      }
    }// metodo inserir

    public void inserir ( Venda a ){
      if ( this.existe( a )== false){
        listaVendas[ indice] = new Venda ( a );
        indice = indice + 1;
      }
    }// metodo inserirVenda

    public int getIndice(){
       return this.indice;
      }

  public boolean existe( Venda a ){
    boolean  achou = false;
    if ( indice == 0) achou = false;
    else{
      for (int i = 0; i < indice; i++){
        if  (listaVendas[i].match( a )) achou = true;
      }//for
    }//else
    return achou;
  }// existe

  public boolean existe( Ticket ticket, int qtdePedida, Comprador comprador){
    boolean  achou = false;
    if ( indice == 0) achou = false;
    else{
      for (int i = 0; i < indice; i++){
        if  ( listaVendas[i].match(ticket,qtdePedida,comprador) )
        achou = true;
      }//for
    }//else
    return achou;
  }// existe


 public Venda[] procurarShowCadeira ( Show show){
   Venda[] retorno = new Venda[1000];
   int ponteiro = 0;

   for (int i = 0; i<this.getIndice(); i++){
     if ( listaVendas[i].getVendaTicket().getTipo() == 1  &&
         listaVendas[i].getVendaTicket().getShow().equals(show) ){
         retorno[ponteiro] = listaVendas[i];
         ponteiro++;
       }//if
     }//for
      return retorno;
   }//  procurarShowCadeiras


  public Venda[] procurarShowMesa ( Show show){
   Venda[] retorno = new Venda[1000];
   int ponteiro = 0;

   for (int i = 0; i<this.getIndice(); i++){
     if ( listaVendas[i].getVendaTicket().getTipo() == 2  &&
          listaVendas[i].getVendaTicket().getShow().equals(show) ){
               retorno[ponteiro] = listaVendas[i];
               ponteiro++;
       }//if
     }//for
      return retorno;
   }//  procurarShowMesas


  public Venda[] procurarShowPe ( Show show){
   Venda[] retorno = new Venda[1000];
   int ponteiro = 0;

   for (int i = 0; i<this.getIndice(); i++){
     if ( listaVendas[i].getVendaTicket().getTipo() == 3  &&
          listaVendas[i].getVendaTicket().getShow().equals(show) ){
               retorno[ponteiro] = listaVendas[i];
               ponteiro++;
       }//if
     }//for
      return retorno;
   }//  procurarShowPe


  public Venda[] listarVendas (){
   Venda[] retorno = new Venda[1000];
   int ponteiro = 0;

   for (int i = 0; i<this.getIndice(); i++){
               if ( listaVendas[i] != null ) {
                   retorno[ponteiro] = listaVendas[i];
                   ponteiro++;
               }

     }//for
      return retorno;
   }//  procurarShow


  public Venda[] listarVendasComprador ( Comprador comprador){
   Venda[] retorno = new Venda[1000];
   int ponteiro = 0;

   for (int i = 0; i<this.getIndice(); i++){

     if(listaVendas[i].getVendaComprador().equals(comprador)){
               retorno[ponteiro] = listaVendas[i];
               ponteiro++;


     } // if
     } //for
      return retorno;
   }//  procurarShow


   public int cadeirasVendidas( Show show){
     int total = 0;
     Venda[] cadVenda = new Venda[1000];

     cadVenda = this.procurarShowCadeira( show );

     for(int i = 0; i < 1000; i++ ){
             total = cadVenda[i].getVendaQtdePedida() + total;

       }//for

       return total;


     }

     public int mesasVendidas( Show show){
     int total = 0;
     Venda[] cadVenda = new Venda[1000];

     cadVenda = this.procurarShowMesa( show );

     for(int i = 0; i < 1000; i++ ){
             total = cadVenda[i].getVendaQtdePedida() + total;

       }//for

       return total;


     }


     public int peVendidas( Show show){
     int total = 0;
     Venda[] cadVenda = new Venda[1000];

     cadVenda = this.procurarShowPe( show );

     for(int i = 0; i < 1000; i++ ){
             total = cadVenda[i].getVendaQtdePedida() + total;

       }//for

       return total;


     }//  peVendidas


     public int qtdeVendida( Show show){
     int total = 0;
       total = this.peVendidas( show ) +
       this.cadeirasVendidas( show ) + this.mesasVendidas( show );

       return total;

     }//       qtdeVendida


     public float lucroVenda( Show show){
     float total = 0;


      float precoPe = this.procurarShowPe( show)[0].getVendaTicket().getValorVenda();
      float precoCadeira = this.procurarShowCadeira( show)[0].getVendaTicket().getValorVenda();
      float precoMesa = this.procurarShowMesa( show)[0].getVendaTicket().getValorVenda();


       total = this.peVendidas( show ) * precoPe +
       this.cadeirasVendidas( show ) * precoCadeira +
       this.mesasVendidas( show ) * precoMesa;

       return total;

     }//  qtdeVendida

    public void remover ( Venda venda ){
    int i,j;
         {
             int posicao = -1;

             for ( i = 0; i < this.getIndice(); i++)  {
             if (listaVendas[i].match( venda )== true)  {
             posicao = i;
             if (listaVendas[i].getVendaTicket().getTipo() == 1 ) {
                listaVendas[i].getVendaTicket().getShow().
                incrementaCadeira(-(venda.getVendaQtdePedida()));
            }

            if (listaVendas[i].getVendaTicket().getTipo() == 2 ) {
                listaVendas[i].getVendaTicket().getShow().
                incrementaMesa(-(venda.getVendaQtdePedida()));
            }

            if (listaVendas[i].getVendaTicket().getTipo() == 3 ) {
                listaVendas[i].getVendaTicket().getShow().
                incrementaEmPe(-(venda.getVendaQtdePedida()));
            }


            if (posicao == (indice - 1)) {// ultima posicao
                     listaVendas[posicao] = null;
                     indice = indice - 1;

            } else  {
                     for ( j = posicao; j < indice - 1; j++)  {
                          listaVendas[j].setVendaComprador(listaVendas[j+1].getVendaComprador());
                          listaVendas[j].setVendaQtdePedida(listaVendas[j+1].getVendaQtdePedida());
                          listaVendas[j].setVendaTicket(listaVendas[j+1].getVendaTicket());
                     }//for
                     listaVendas[indice-1]= null;
                     indice = indice - 1;
                 }//else
             }//for
         }//if
        }//if
       }//remover

     public IteratorVenda getIterator(){
        int i = 0;
        IteratorVendaArray iterator = new IteratorVendaArray();
        while(listaVendas[i] != null){
            iterator.add(listaVendas[i]);
            i++;
        }//while
        return iterator;
     }//getIterator


}//classe
